# Frappy Framework

current running code at SINQ, with newest changes not yet pushed
through the Gerrit workflow at MLZ

branches:

- mlz: master from forge.frm2.tum.de:29418/sine2020/secop/playground
  this is not present at git.psi.ch:sinqdev/frappy.git!
- master: keep in sync with above before pushing to psi repo (git.psi.ch:sinqdev/frappy.git)
- work: current working version, usually in use on /home/l_samenv/frappy (and on neutron instruments)
  this should be a copy of an earlier state of the wip branch
- wip: current test version, usually in use on /home/l_samenv/frappy_wip
- lastsynced: the last synced state between mlz and wip


lastsynced --> master
lastsynced --> work --> wip

apply commits from master to work: (rebase ?) or use cherry-pick:

   git cherry-pick <sha1>..<sha2>

where sha1 is the last commit already in wip, and sha2 ist the last commit to be applied
(for a single commit <sha1>.. may be omitted)

the wip branch is also present in an other directory (currently zolliker/switchdrive/gitmlz/frappy),
where commits may be cherry picked for input to Gerrit. As generally in the review process some additonal
changes are done, eventually a sync step should happen:

1) make copies of branches work and wip
2) pull changes from mlz repo to mlz branch
3) merge to master: git checkout master / git merge mlz / git push
4) cherry-pick commits (from master) to lastsynced
5) copy lastsynced branch to wip with 'git checkout -B wip'.
   Not sure if this works, as wip is to be pushed to git.psi.ch.
   We might first remove the remote branch with 'git push origin --delete wip'.
   And then create again (git push origin wip)?
6) in wip: cherry-pick commits not yet feeded into Gerrit from copy in step (1)
7) decide from where to take new work branch (probably from wip)
8) delete branch copies not needed any more
